#!/bin/sh
# LGPL Barry Kauler 2007 www.puppyos.com
#   this must be run with GINS:
#   gins /usr/sbin/set-xftdpi.sh
# invoked from menu Desktop --> Set global font size.

PSREAD="`ps`"
if [ "`echo -n "$PSREAD" | grep 'gins' | grep 'xftdpi'`" = "" ];then
 echo "ERROR, must be run by 'gins /usr/sbin/set-xftdpi.sh'"
 exit 1
fi

#read current dpi setting...
CURRDPI=`cat /root/.Xresources | grep "^Xft\\.dpi:" | tr '\t' ' ' | tr -s ' ' | cut -f 2 -d ' '`
[ ! $CURRDPI ] && CURRDPI=78
CURRINDEX=`expr $CURRDPI \/ 6`
CURRINDEX=`expr $CURRINDEX - 9`

#gui created by glade...
echo "[OPEN]"
echo "/usr/sbin/set-xftdpi.glade"

#preset selected radiobutton...
echo '[SET]'
echo "radiobutton${CURRINDEX}"
echo 'active' #active
echo 'TRUE'
echo '<boolean>'

rm -f /tmp/stdout.log
BUTNUM=

#loop to handle events from gui...
while true
do
	read obj event pdata
	
 echo "obj=$obj event=$event pdata=$pdata" >>/tmp/stdout.log
 
 #handle the radiobuttons...
 if [ ! "`echo "$obj" | grep 'radiobutton[0-9]'`" = "" ];then
  if [ "$event" = "GDK_BUTTON_RELEASE" ];then
   #get button number...
   BUTNUM=`echo -n "$obj" | sed -e 's/radiobutton//g'`
  fi
 fi
 
 #handle close box on window...
 if [ "$obj" = "window1" ]; then
  if [ "$event" = "GDK_DELETE" ]; then 
   echo "[QUIT]"
   exit 0
  fi
 fi

 #handle Cancel button...
 if [ "$obj" = "button3" ]; then
  if [ $event = "GDK_BUTTON_RELEASE" ]; then
   echo "[QUIT]"
   exit 0
  fi
 fi

 #handle Apply button...
 if [ "$obj" = "button1" ]; then
  if [ $event = "GDK_BUTTON_RELEASE" ];then
   if [ $BUTNUM ];then
    NEWDPI=`expr $BUTNUM + 9`
    NEWDPI=`expr $NEWDPI \* 6`
    TMP1="`cat /root/.Xresources | grep -v "Xft\\.dpi:"`"
    echo "$TMP1" > /root/.Xresources
    echo "Xft.dpi: $NEWDPI" >> /root/.Xresources
    sync
   fi
   echo "[QUIT]"
   exit 0
  fi
 fi

done
